''P1V - Pin assignments
CON

        _clkmode = xtal1 + pll16x
        _clkfreq =  80_000_000

        'PortA pin assignments
        P00             = 0     'PIN_T19
        P01             = 1     'PIN_T20
        P02             = 2     'PIN_T18
        P03             = 3     'PIN_T17
        P04             = 4     'PIN_T22
        P05             = 5     'PIN_R22
        P06             = 6     'PIN_T15
        P07             = 7     'PIN_R15
        P08             = 8     'PIN_R21
        P09             = 9     'PIN_P22
        P10             = 10    'PIN_R16
        P11             = 11    'PIN_R17
        P12             = 12    'PIN_P19
        P13             = 13    'PIN_P18
        P14             = 14    'PIN_P16
        FPGA_RGB_LEDS   = 15    'PIN_G6
        LED00           = 16    'PIN_H13
        LED01           = 17    'PIN_G13
        LED02           = 18    'PIN_G11
        LED03           = 19    'PIN_F12
        LED04           = 20    'PIN_D13
        LED05           = 21    'PIN_C13
        LED06           = 22    'PIN_B12
        LED07           = 23    'PIN_A12
        PB0             = 24    'PIN_M7
        PB1             = 25    'PIN_M6
        PB2             = 26    'PIN_P7
        PB3             = 27    'PIN_R7

        'PortB pin assignments
        P32             = 0     'PIN_AB5
        P33             = 1     'PIN_AB6
        P34             = 2     'PIN_V10
        P35             = 3     'PIN_V9
        P36             = 4     'PIN_N8
        P37             = 5     'PIN_P8
        P38             = 6     'PIN_AB7
        P39             = 7     'PIN_AA7
        P40             = 8     'PIN_AB8
        P41             = 9     'PIN_AA8
        P42             = 10    'PIN_U10
        P43             = 11    'PIN_T9
        P44             = 12    'PIN_M9
        P45             = 13    'PIN_M8
        P46             = 14    'PIN_AA9
        P47             = 15    'PIN_AA10
        LED08           = 16    'PIN_H11
        LED09           = 17    'PIN_G12
        LED10           = 18    'PIN_L8
        LED11           = 19    'PIN_K9
        LED12           = 20    'PIN_D12
        LED13           = 21    'PIN_E12
        LED14           = 22    'PIN_C11
        LED15           = 23    'PIN_B11
        EXPC0           = 24    'PIN_A8
        EXPC1           = 25    'PIN_A7
        EXPC2           = 26    'PIN_C6
        EXPC3           = 27    'PIN_D6
        EXPC4           = 28    'PIN_E9
        EXPC5           = 29    'PIN_D9
        EXPC6           = 30    'PIN_D7
        EXPC7           = 31    'PIN_C8

        'PortC pin assignments
        DAC0_R0         = 0     'PIN_H21
        DAC0_R1         = 1     'PIN_G21
        DAC0_R2         = 2     'PIN_E21
        DAC0_R3         = 3     'PIN_D21
        DAC0_R4         = 4     'PIN_E19
        DAC0_R5         = 5     'PIN_D19
        DAC0_R6         = 6     'PIN_C20
        DAC0_R7         = 7     'PIN_B20
        DAC0_R8         = 8     'PIN_J21
        DAC0_R9         = 9     'PIN_J22
        DAC0_G0         = 10    'PIN_B18
        DAC0_G1         = 11    'PIN_B17
        DAC0_G2         = 12    'PIN_C21
        DAC0_G3         = 13    'PIN_B21
        DAC0_G4         = 14    'PIN_G22
        DAC0_G5         = 15    'PIN_F22
        DAC0_G6         = 16    'PIN_G20
        DAC0_G7         = 17    'PIN_H20
        DAC0_G8         = 18    'PIN_E22
        DAC0_G9         = 19    'PIN_D22
        DAC0_B0         = 20    'PIN_C19
        DAC0_B1         = 21    'PIN_C18
        DAC0_B2         = 22    'PIN_B22
        DAC0_B3         = 23    'PIN_A22
        DAC0_B4         = 24    'PIN_F19
        DAC0_B5         = 25    'PIN_F18
        DAC0_B6         = 26    'PIN_E20
        DAC0_B7         = 27    'PIN_F20
        DAC0_B8         = 28    'PIN_A18
        DAC0_B9         = 29    'PIN_A17
        DAC0_CLK        = 30    'PIN_A20

        'PortD pin assignments
        DAC1_R0         = 0     'PIN_A19
        DAC1_R1         = 1     'PIN_K20
        DAC1_R2         = 2     'PIN_K19
        DAC1_R3         = 3     'PIN_B16
        DAC1_R4         = 4     'PIN_C16
        DAC1_R5         = 5     'PIN_D17
        DAC1_R6         = 6     'PIN_E16
        DAC1_R7         = 7     'PIN_G17
        DAC1_R8         = 8     'PIN_G16
        DAC1_R9         = 9     'PIN_G18
        DAC1_G0         = 10    'PIN_H18
        DAC1_G1         = 11    'PIN_J19
        DAC1_G2         = 12    'PIN_J18
        DAC1_G3         = 13    'PIN_E15
        DAC1_G4         = 14    'PIN_F15
        DAC1_G5         = 15    'PIN_A15
        DAC1_G6         = 16    'PIN_A14
        DAC1_G7         = 17    'PIN_J17
        DAC1_G8         = 18    'PIN_K16
        DAC1_G9         = 19    'PIN_C15
        DAC1_B0         = 20    'PIN_B15
        DAC1_B1         = 21    'PIN_G15
        DAC1_B2         = 22    'PIN_F14
        DAC1_B3         = 23    'PIN_H14
        DAC1_B4         = 24    'PIN_J13
        DAC1_B5         = 25    'PIN_B13
        DAC1_B6         = 26    'PIN_A13
        DAC1_B7         = 27    'PIN_E14
        DAC1_B8         = 28    'PIN_F13
        DAC1_B9         = 29    'PIN_J11
        DAC1_CLK        = 30    'PIN_H10


        nco_mode = %00100 << 26
        
obj

rgb:    "jm_ws2812_ss"
comms:  "fullduplexserial"

var

  long  mystack[20]
  long  mystack2[20]
  long  mystack3[20]

  long  pin,pin2
  long  clr
  long  color[8]
  
    
PUB main


  cognew(test1,@mystack)
  cognew(test2,@mystack2)
  cognew(process,@mystack3)

  color[0] := rgb#red
  color[1] := rgb#green
  color[2] := rgb#blue
  color[3] := rgb#magenta
  color[4] := rgb#yellow
  color[5] := rgb#cyan
  color[6] := rgb#orange
  color[7] := rgb#white
  

  rgb.start_b(4)
  
  repeat
      rgb.setx(0,color[clr],20,-1)
      rgb.setx(1,color[clr],10,-1)
      rgb.setx(2,color[clr],10,-1)
      rgb.setx(3,color[clr],10,-1)
      rgb.execute(fpga_rgb_leds,-1,-1)
      waitcnt(cnt+clkfreq)
      clr++
      clr &= 7
      
 
pri test1|x

    outa[led07..led00] := $ff
    dira[led07..led00] := $ff
    
    repeat

      repeat x from led00 to led07
        outa[x] := 0
        waitcnt(cnt+clkfreq>>3)
        outa[x] := 1

      outa[led07] := 0
      waitcnt(cnt+clkfreq)
        
      repeat x from led07 to led00
        outa[x] := 0
        waitcnt(cnt+clkfreq>>3)
        outa[x] := 1
        
      outa[led00] := 0
      waitcnt(cnt+clkfreq)
        
pri test2|x

    outb[led15..led08] := $ff
    dirb[led15..led08] := $ff
    
    repeat

      repeat x from led08 to led15
        outb[x] := 0
        waitcnt(cnt+clkfreq>>2)
        outb[x] := 1
        
      repeat x from led15 to led08
        outb[x] := 0
        waitcnt(cnt+clkfreq>>2)
        outb[x] := 1


pri process|key

  comms.start(31,30,0,115200)



  frqa := fraction(3,clkfreq,0)
  frqb := fraction(5,clkfreq,0)
    
    repeat
                        
      key := comms.rx

        case key

          "+": pin++

          "-": pin--
          
          "u": pin2++
          
          "d": pin2--
          
        pin &= 15
        pin2 &= 15

       dira := 1 << pin
       outa := 0
       ctra := nco_mode | pin

       dirb := 1 << pin2
       outb := 0
       ctrb := nco_mode | %100000 | pin2
              
       comms.str(string("pin="))
       comms.dec(pin)
       comms.tx(32)
       comms.str(string("pin2="))
       comms.dec(pin2)
       comms.tx(13)
       
       

PRI fraction(a, b, shift) : f

  if shift > 0                         'if shift, pre-shift a or b left
    a <<= shift                        'to maintain significant bits while 
  if shift < 0                         'insuring proper result
    b <<= -shift
 
  repeat 32                            'perform long division of a/b
    f <<= 1
    if a => b
      a -= b
      f++           
    a <<= 1
          